Package org.apache.commons.imaging.formats.tiff.photometricinterpreters

## Class PhotometricInterpreter

- java.lang.Object
- - org.apache.commons.imaging.formats.tiff.photometricinterpreters.PhotometricInterpreter

- Direct Known Subclasses:
    `PhotometricInterpreterBiLevel`, `PhotometricInterpreterCieLab`, `PhotometricInterpreterCmyk`, `PhotometricInterpreterFloat`, `PhotometricInterpreterLogLuv`, `PhotometricInterpreterPalette`, `PhotometricInterpreterRgb`, `PhotometricInterpreterYCbCr`

      public abstract class PhotometricInterpreter
      extends Object

  Interpreter for photometric information in TIFF images. The photometric interpretation tag is a requirement for valid TIFF images, and defines the color space of the image data.
  See Also:
    Baseline TIFF Tag PhotometricInterpretation

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected int` | `height` |
    `protected int` | `predictor` |
    `protected int` | `samplesPerPixel` |
    `protected int` | `width` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PhotometricInterpreter​(int samplesPerPixel, int[] bitsPerSample, int predictor, int width, int height)` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected int` | `getBitsPerSample​(int offset)` |
    `abstract void` | `interpretPixel​(ImageBuilder imageBuilder, int[] samples, int x, int y)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### samplesPerPixel

          protected final int samplesPerPixel

    - #### predictor

          protected final int predictor

    - #### width

          protected final int width

    - #### height

          protected final int height

  - ### Constructor Detail

    - #### PhotometricInterpreter

          public PhotometricInterpreter​(int samplesPerPixel,
                                        int[] bitsPerSample,
                                        int predictor,
                                        int width,
                                        int height)

  - ### Method Detail

    - #### interpretPixel

          public abstract void interpretPixel​(ImageBuilder imageBuilder,
                                              int[] samples,
                                              int x,
                                              int y)
                                       throws ImageReadException,
                                              IOException

      Throws:
        `ImageReadException`
        `IOException`

    - #### getBitsPerSample

          protected int getBitsPerSample​(int offset)